
# Lacmus

### SOFTWARE REQUIREMENTS SPECIFICATION ISO-IEEE-29148-2011

Основные сокращения:
- БПЛА - беспилотный летательный аппарат;


## 1. Назначение приложения Lacmus

- поиск людей на фотоснимках местности, сделанных с помощью БПЛА;
- сбор и хранение фотографий, формирования датасета для более качественного обучения нейросетей.

## 2. Область применения
#### 2.1 Уникальное название, по которому можно будет отличить от других программ - **Lacmus**

#### 2.2 Общая логика работы Lacmus

1. Оператор определяется участок местности, в котором будет осуществляться поиск пропавшего человека и запускает БПЛА в соответствии с подготовленным маршрутом.

2. БПЛА осуществляет фото съемку и передает информацию на локальную машину оператора (ноутбук) с установленным ПО Lacmus (RescuerLaApp).

3. С локальной машины полученные снимки отправляются на виртуальный сервер (docker service), который обрабатывает снимки с помощью нейросети. В случае обнаружения человека на снимке делается отметка в виде прямоугольника.


#### 2.3 Относительные преимущества и миссия Lacmus

На сегодняшний день обработка снимков с БПЛА при поиске пропавших людей осуществляется в основном операторами вручную, что получается долго и не очень точно. Неплохие результаты получаются при обработке снимков с тепловизоров, однако такая аппаратура довольно дорогая и не всегда доступна добровольцам.

Основные преимущества Lacmus (RescuerLaApp) - это возможность автоматического поиска людей на снимках, сделанных с помощью относительно недорогих моделей БПЛА. Применение Lacmus в некоммерческом проекте Liza Alert позволит повысить шансы отыскания и сократить время на обнаружение пропавшего человека.  
**Важно!** Lacmus не должен применяться в военных или иных целях, направленных на причинение вреда жизни или здоровью людей.

## 3. Обзор Lacmus

#### 3.1 Системный интерфейс

Общая структура системы и указание функций ПО, обеспечивающих связь между элементами приведена на рисунке 1.

<img src="imgs/skhemes/RescuerLaAppSkheme-v1.png">

#### 3.2 Пользовательские интерфейсы

а) Логика работы интерфейса пользователя.

Интерфейс пользователя изображен на рисунке 2

<img src="imgs/screenshot.png">

Интерфейс пользователя состоит из следующих элементов:

MenuBar (Стандарное меню приложения):

File (Операции с файлами изображений):
- Open directory - открывает окно выбора рабочей директории с изображениями;
- Predict all - проводит обработку всех снимков в выбранной директории;
- Save  - сохраняет аннотации к обработанным изображениям;
- Show all - ???
- Exit - Закрывает приложение.

Model (Операции с нейросетевой моделью):
- Load Model - загрузить модель на локальную машину;
- Update Model - обновить модель (синхрозация с сервером).

Image (Операции с изображениями):
- Predict this - обработать текущее выделенное изображение;
- Predict all - обработать все изображения в рабочей директории;
- Increase - увеличить масштаб изображения;
- Shrink - уменьшить масштаб изображения;
- Next - выбрать следующее изображение;
- Prev - выбрать предыдущее изображение.

Help:
- Open user guide - открыть руководство пользователя;
- About - вывести окно с информацией о текущей версии приложения.

ToolBar:
- Open - открывает окно выбора рабочей директории с изображениями;
- Predict all - проводит обработку всех снимков в выбранной директории;
- Increase - увеличить масштаб изображения;
- Shrink - уменьшить масштаб изображения;
- Next - выбрать следующее изображение;
- Prev - выбрать предыдущее изображение.

ImageArea: Область для показа текущего выбранного изображения.

ShowPedestriansCheckBox: Опция выбора отображения найденных людей.

StatusBar: Информация о текущем статусе приложения.


б) Аспекты взаимодействия приложения, пользователя и администратора.
(В простом случае это может быть просто список разрешенных и не разрешенных действий для пользователя. Более подробно эти аспекты могут описываются в Техническом описании и/или Руководстве пользователя.)

#### 3.3 Аппаратные интерфейсы

Передача изображений с БПЛА на локальную машину может осуществляться с помощью съемного носителя (USB или SD карты). В перспективе возможна передача видео по радиоканалу (Wi-Fi) и обработка в реальном времени.

#### 3.4 Программные интерфейсы

Для работы приложения на локальной машине обязательно нужен установленный docker-ce. Все зависимости (ОС, СУБД, вычислительные пакеты) уже включены в контейнер. Список зависимостей можно посмотреть в файле Dockerfile.

#### 3.5 Интерфейсы связи
Так как исследования по улучшению нейросетевых моделей находятся в активной фазе, для работы приложения обязательно наличие доступа в Интернет для загрузки актуальной версии docker-контейнера c упакованной обученной нейросетью.

#### 3.6 Ограничение на использование памяти
Отдельные ограничения на занимаемый объем ПО и количество потребляемой памяти - не более 4 Гб.

#### 3.7 Операции:

- перенос файлов с накопителя БПЛА на локальную машину;  
- выбор рабочей директория с изображениями;  
- создание защищенного соединения с сервером через интернет, авторизация
- загрузка файла нейросетевой модели на локальную машину;  
- запуск docker service на локальном хосте;  
- обмен изображениями между основным процессом и виртуальным сервером (докер);  
- инференс на виртуальном сервере;  - 

- Различные режимы взаимодействия с пользователем (например, регистрация нового пользователя);  
- Периоды интерактивных операций и фоновых процессы;  
- Функции обеспечения обработки данных;  
- Операции резервного копирования и восстановления и т.д.  


#### 3.8 Требования к адаптации входных данных.

а) Требования ко входным данным - размер изображений не более 1600х1600, допускаемые форматы - jpg, png.

б) Определение объектов и функций, реализуемых в конкретном варианте установки.


## 4. Общие функции ПО
Функционально Lacmus разделен на клиент и сервер. В текущей версии использован виртуальный сервер (docker service) поэтому приложение может работать на локальной машине без доступа к интернет (при условии что необходимый контейнер предварительно загружен).

Входные данные (изображения или видео) переносятся с карты памяти камеры БПЛА на локальную машину. После запуска приложения Lacmus командой Open выбирается рабочая директория с изображениями. Затем дается команда Predict all (predict this), по которой приложение в фоновом режиме , создает защищенное соединение с сервером через интернет, проходит авторизацию и загружает нейросетевую модель на локальную машину. После успешной загрузки модели на локальном хосте запускается docker service, при успешной загрузке виртуальный сервер отправляет приложению json-сообщение "is running". После этого изображения отправляются на сервер (в докер). Виртуальный сервер обрабатывает изображения. По окончании обработки сервер останавливается.

Архитектура back-end приведена на рисунке 3.

<img src="imgs/RescuerLaBackendSkheme-v1.png">


## 5. Характеристика пользователей
GUI Lacmus должен быть по возможности простым и интуитивно понятным. Для использования приложения особых требований к навыкам пользователей не предъявляется.


## 6. Ограничения

Возможные факторы, которые могут повлиять на процесс разработки ПО:  
а) Политики регулирования  
б) Аппаратные ограничения (например, требования по синхронизации)  
в) Интерфейсы других приложений  
г) Параллельные операции  
д) Функции аудита (контроля)  
е) Функции управления  
ж) Слабо формализованные требования  
з) Квитирования (рукопожатие) сигналов  
и) Требования к качеству ПО (например, надежности)  
к) Важность ПО  
л) Требования к безопасности и конфиденциальности  
м) Физические и психофизические ограничения  

## 7. Допущения и зависимости

Базовое приложение Lacmus работает на CPU в ОС Windows/Linux/MacOS. Существует тестовая версия с поддержкой ускорения с GPU (Cuda), но только в ОС Linux.

Требования к CPU: 2x+ Core CPU (with AVX, SSE SSE2 SSE3 SSE4 SSE4.1) Intel Core i3/i5/i7/xeon Sandy Bridge / AMD Buldozer and higher (Intel Celeron не поддерживают AVX)  
Требования к GPU: GTX, 4Gb vRAM, CUDA 9.1+ comparable (including CUDA 10 and higher), no CUDA driver required, e.g. GTX 950m and higher  
RAM: 4096 mb RAM and higher  
Storage: 5gb free disk space (10gb free disk space for GPU version)  


## 8. Распределение требований между элементами ПО

Те требования, реализация которых требует нескольких элементов ПО, должны быть особо выделены. Также возможна ситуация, в которой тяжело установить однозначное соответствие между элементами ПО и функциями, которые закрывают определенные требования, это тоже следует указать. Для однозначного определения соответствия между элементами ПО и функциями, которые закрывают определенные требования, целесообразно использовать таблицу соответствия.

## 9. Документированные требования

Все требования к ПО должны быть описаны с такой степенью детализации, которая позволит программистам полностью удовлетворить заданные требования. Однозначное и непротиворечивое описание требований должно обеспечить написание и проведение тестов.
Как минимум, необходимо описать все входы и сигналы, подаваемые на элементы ПО, а также выходы и отклики, которые необходимо получить.
Все документированные требования должны удовлетворять следующим условиям:  
а) Быть согласованными с характеристиками, указанными в п. 5.2   Стандарта.
б) Прослеживаться к предыдущим требованиям.  
в) Быть однозначно идентифицируемыми.  

## 10. API  
#### Взаимодействие между клиентом и сервером:  
а) Название интерфейса - client-server API:  
б) Описание целей:
- авторизация клиента;  
- передача изображений с клиента на сервер;  
- создание задачи по обработке изображения на сервере.  

в) Источник запросов - desktop приложение Lacmus  
г) Допустимый размер изображений - 1600х1600px  
д) Формат изображений - jpg, png    
е) Синхронизация - нет  
ж) Взаимосвязь с другими входами/выходами - нет   
з) Запрос на регистрацию и подключение клиента - json строка  
к) Формат команд -  { "data": base64 string image data }  
л) Команда завершения сеанса  на сервере - json строка  

#### Взаимодействие между сервером и клиентом:  
а) Название интерфейса - server-client API;  
б) Описание целей:
- передача обработанных изображений с сервера на клиент;  

в) Источник запросов - Lacmus server;  
д) Формат сообщения - json;    
е) Синхронизация - нет  
ж) Взаимосвязь с другими входами/выходами - нет   
з) Запрос на регистрацию и подключение клиента - json строка  
к) Формат команд -  { "data": base64 string image data }  
л) Команда завершения сеанса  на сервере - json строка  


## 11. Функциональные требования  

Основные функции, которые реализованы в Lacmus:  
а) Операции по проверке входных данных;    
б) Операции по обработке данных;    
г) Обработка ненормальных ситуаций (переполнение, гибкость связи, обработка ошибок и восставновление);  


## 12. Требования к UI/UX
GUI должен обеспечивать возможность подачи всех функциональных команд, вывод результата обработки на экран и сохранение в файл. 

## 13. Требования к производительности
Статистические требования:  
а) Число терминалов, которые могут работать одновременно - один.  
б) Число пользователей, которые могут одновременно использовать систему - один.  

Динамические требования:   
a) Минимальная скорость обработки изображений - 1 fps.  


## 14. Требования к базе данных

Логические требования должны быть определены для всей информации, которая хранится в базе данных, вкл:  
а) Тип информации, используемой для различных функций  
б) Частота использования  
в) Возможности доступа  
г)  Сущность данных и их взаимосвязи  
д) Ограничения интеграции  
е) Требования к способности хранения данных  

## 15. Особенности разработки   

Основная часть Lacmus написана на C# и python. Постановка и учет задач ведется в Trello https://trello.com/b/oGWhHnAR/projrescuerla (подробности по Trello в списке INFO). Обсуждения хода разработки в Slack https://opendatascience.slack.com в закрытом канале #proj_rescuer_la (заявка на добавление через канал #ml4sg). Исходный код проекта https://github.com/lizaalert/lacmus  

## 16. Соблюдение требований нормативных документов  

Существующие стандарты и рекомендации не накладывают ограничений на проект. Однако при запуске БПЛА нужно убедиться, что это не нарушает действующий законов.   


## 17. Основные характеристики ПО
a) Вероятность успешного распознования человека на изображении - не менее 60%.  
b) Минимальное время работы приложения без сбоев - 4 часа.  
c) Безопасность (защита от намеренных и непреднамеренных ошибок):  
- Доступ к серверу - только авторизованные пользователи;  
- Шифрование сообщений - не применяется;  
- Логгирование основных событий - в файл / консоль;

d) Модульность - добавление нового функционала не ведет к необходимости переписывать существующий код.  
e) Портабельность - клиентская часть работает на основных ОС: Windows/Linux/MacOS.

## 18. Верификация требований

Unit тестирование модулей и API (п.10), интеграционное тестирование системы в целом (п.17). Отчеты по тестам публиковать в github.  

## 19. Дополнительная информация

Дополнительная информация может понадобиться для поддержки приложения на этапе разработки, внедрения и эксплуатации:  
а) Образцы входных и выходных данных, анализ стоимости обучения, результаты опросы пользователей.  
б) Дополнительная информация, которая поможет в понимании данного ТЗ.  
в) Описание задач, которые решает ПО.  
г) Специальные инструкции по интеграции, установке ПО, обеспечение сохранности информации и другие требования.  

ТЗ на разработку ПО должно быть однозначно определено и утверждено в текущем состоянии. Требования к ПО могут изменяться. Все изменения требований к ПО должны быть явным образом зафиксированы и отражены.
